config/routes.rb
Rails.application.routes.draw do
  resources :client_measure_histories
  resources :training_clients
  resources :repetitions
  resources :numbers
  resources :exercises
  resources :equipaments
  resources :client_payment_histories
  resources :clients
  #resources :plan_service_clients
  resources :service_clients
  resources :plan_clients
  resources :gym_payment_histories
  resources :coaches
  resources :gyms
  #resources :plan_service_managers
  resources :service_managers
  resources :plan_managers
  resources :managers
  resources :admins

  root to: 'application#home'

  devise_for :users, path: '', path_names: { sign_in: 'login', sign_out: 'logout', sign_up: 'register', edit: 'settings' }
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  get '/home', to: 'application#home', as: 'home'
  get '/secret', to: 'application#secret', as: 'secret'

  get '/manager_clients', to: 'managers#show_clients'
  get '/manager_coaches', to: 'managers#show_coaches'

  get '/admin_managers', to: 'admins#show_managers'
  get '/admin_managers/:email', to: 'admins#show_manager'
  get '/gym_payments/:id',  to: 'gyms#payments'

  # token auth routes available at /api_application/mobile/auth
  namespace :api_application do
    scope :mobile do
      mount_devise_token_auth_for 'UserMobile', at: 'auth'
    end
  end

  devise_scope :user_mobile do
    get 'api_application/mobile/mobile_profile', to: 'mobile#mobile_profile'
    get 'api_application/mobile/profile_payments', to: 'mobile#profile_payments'
    get 'api_application/mobile/profile_training', to: 'mobile#profile_training'
    get 'api_application/mobile/profile_measures', to: 'mobile#profile_measures'

  end

end

app/models/admin.rb
class Admin < ApplicationRecord
  belongs_to :user
end

app/models/client.rb
class Client < ApplicationRecord
  belongs_to :user
  belongs_to :gym
  belongs_to :plan_client

  has_many :client_payment_histories
  has_many :training_clients
  has_many :client_measure_histories
end

app/models/coach.rb
class Coach < ApplicationRecord
  belongs_to :user
  belongs_to :gym

  has_many :trainings
end

app/models/equipament.rb
class Equipament < ApplicationRecord
  belongs_to :gym

  has_many :trainings
end

app/models/exercise.rb
class Exercise < ApplicationRecord
  belongs_to :gym

  has_many :trainings

end

app/models/gym.rb
class Gym < ApplicationRecord
  belongs_to :manager
  belongs_to :plan_manager

  has_many :coaches
  has_many :gym_payment_histories
  has_many :clients
  has_many :service_clients
  has_many :equipaments
  has_many :exercises
  has_many :numbers
  has_many :repetitions

end

app/models/manager.rb
class Manager < ApplicationRecord
  belongs_to :user
  has_many :gyms
end

app/models/measure.rb
class Measure < ApplicationRecord
  has_many :client_measure_histories
end

app/models/muscle_type.rb
class MuscleType < ApplicationRecord

  has_many :trainings

end

app/models/number.rb
class Number < ApplicationRecord
  belongs_to :gym

  has_many :trainings

end

app/models/plan_client.rb
class PlanClient < ApplicationRecord
  belongs_to :gym

  has_many :plan_service_clients
  has_many :clients

end

app/models/plan_manager.rb
class PlanManager < ApplicationRecord
  has_many :plan_service_managers
  has_one :gym
end

app/models/repetition.rb
class Repetition < ApplicationRecord
  belongs_to :gym

  has_many :trainings

end

app/models/service_client.rb
class ServiceClient < ApplicationRecord
  belongs_to :gym
  has_many :plan_service_clients
end

app/models/training.rb
class Training < ApplicationRecord
  belongs_to :coach
  belongs_to :equipament
  belongs_to :exercise
  belongs_to :number
  belongs_to :repetition
  belongs_to :muscle_type
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable

  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable


  has_many :admis
  has_many :Managers
  has_many :coaches
  has_many :clients
end

app/models/user_mobile.rb
class UserMobile < ActiveRecord::Base
  # Include default devise modules.
  devise :database_authenticatable, :registerable,
          :recoverable, :rememberable, :trackable, :validatable,
          #:confirmable,
          :omniauthable
  include DeviseTokenAuth::Concerns::User

  def self.is_valid_token(token, client_id)
    @resource.valid_token?(token, client_id)
  end

end

app/controllers/plan_managers_controller.rb
class PlanManagersController < ApplicationController
  before_action :set_plan_manager, only: [:show, :edit, :update, :destroy]
  before_action :manager_block_acess
  before_action :authenticate_user!

  # GET /plan_managers
  # GET /plan_managers.json
  def index
    if current_user
      @plan_managers = PlanManager.all
      @admin = Admin.find_by_user_id(current_user)
    end
  end

  # GET /plan_managers/1
  # GET /plan_managers/1.json
  def show
    @services = PlanServiceManager.where(:plan_manager_id => @plan_manager.id).all
    name = Array.new
    price = Array.new
    @services.each do |s|
      name.push(s.service_manager.name)
      price.push(s.service_manager.price)
    end
    @response = {"service": name,"price": price}
    render_json(200,@response)
  end

  # GET /plan_managers/new
  def new
    @plan_manager = PlanManager.new
    @service_managers = ServiceManager.all.order('name ASC')
  end

  # GET /plan_managers/1/edit
  def edit
  end

  # POST /plan_managers
  # POST /plan_managers.json
  def create
    @plan_manager = PlanManager.new(plan_manager_params)
    @plan_manager.price = 0
    if @plan_manager.save
      @service_idies = params[:plan_service_manager][:service_manager_id]
      @service_idies.each do |servico_id|
        @service_manager = ServiceManager.find(servico_id)
        PlanServiceManager.create(:plan_manager_id => @plan_manager.id, :service_manager_id => servico_id)
        @plan_manager.price += @service_manager.price
      end

      if @plan_manager.update(:name => @plan_manager.name, :price => @plan_manager.price)
        redirect_to plan_managers_path, notice: 'Plano cadastrado com sucesso'
      else
        redirect_to plan_managers_path, notice: 'Impossivel calcular o valor do plano'
      end

    else
      redirect_to plan_managers_path, notice: 'Plano não foi cadastrado!'
    end

  end

  # PATCH/PUT /plan_managers/1
  # PATCH/PUT /plan_managers/1.json
  def update
    respond_to do |format|
      if @plan_manager.update(plan_manager_params)
        format.html { redirect_to @plan_manager, notice: 'Plan manager was successfully updated.' }
        format.json { render :show, status: :ok, location: @plan_manager }
      else
        format.html { render :edit }
        format.json { render json: @plan_manager.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /plan_managers/1
  # DELETE /plan_managers/1.json
  def destroy

    @service_managers = PlanServiceManager.where(:plan_manager_id => @plan_manager.id).all
    @service_managers.each do |s|
      s.destroy
    end

    @plan_manager.destroy
    respond_to do |format|
      format.html { redirect_to plan_managers_url, notice: 'Plan manager was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_plan_manager
      @plan_manager = PlanManager.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def plan_manager_params
      params.require(:plan_manager).permit(:name, :price)
    end
end

app/helpers/admins_helper.rb
module AdminsHelper
end

app/helpers/clients_helper.rb
module ClientsHelper
end

app/helpers/gyms_helper.rb
module GymsHelper
end

app/helpers/mobile_helper.rb
module MobileHelper
end

app/helpers/plan_managers_helper.rb
module PlanManagersHelper
end

app/views/plan_managers/_form.html.erb
<form action="/plan_managers" accept-charset="UTF-8" method="post">

  <div class="form-group">
    <label for="plan_manager_name">Nome</label>
    <input type="text" class="form-control" autofocus="autofocus" name="plan_manager[name]" id="plan_manager_name">
  </div>
  <div class="form-group">
    <label for="plan_service_manager_service_manager_id">Serviços</label>
      <select class="form-control" multiple id="plan_service_manager_service_manager_id" name="plan_service_manager[service_manager_id][]">
        <% @service_managers.each do |service_manager| %>
          <option value = <%= service_manager.id %>><%= service_manager.name %>  |  <%= service_manager.price %> R$</option>
        <% end %>
      </select>
  </div>
  </br>
  <button type="submit" class="btn btn-primary" name="commit" value="Create Plan manager" data-disable-with="Create Plan manager"/>Cadastrar</button>

</form>

app/views/plan_managers/edit.html.erb
<h1>Editing Plan Manager</h1>

<%= render 'form', plan_manager: @plan_manager %>

<%= link_to 'Show', @plan_manager %> |
<%= link_to 'Back', plan_managers_path %>

app/views/plan_managers/index.html.erb
<!DOCTYPE html>
<html>
<style>
/* The Modal (background) */
.modal {
  display: none; /* Hidden by default */
  position: fixed; /* Stay in place */
  z-index: 1; /* Sit on top */
  padding-top: 100px; /* Location of the box */
  left: 0;
  top: 0;
  padding-left: 8cm;
  width: 100%; /* Full width */
  height: 100%; /* Full height */
  overflow: auto; /* Enable scroll if needed */
  background-color: rgb(0,0,0); /* Fallback color */
  background-color: rgba(0,0,0,0.4); /* Black w/ opacity */
}
.modal-content {
    position: relative;
    background-color: #E3F2FD;
    margin: auto;
    padding: 0;
    border: 1px solid #888;
    width: 80%;
    box-shadow: 0 4px 8px 0 rgba(0,0,0,0.2),0 6px 20px 0 rgba(0,0,0,0.19);
    -webkit-animation-name: animatetop;
    -webkit-animation-duration: 0.4s;
    animation-name: animatetop;
    animation-duration: 0.4s
}

/* Add Animation */
@-webkit-keyframes animatetop {
    from {top:-300px; opacity:0}
    to {top:0; opacity:1}
}

@keyframes animatetop {
    from {top:-300px; opacity:0}
    to {top:0; opacity:1}
}

/* The Close Button */
.close {
    color: white;
    float: right;
    font-size: 28px;
    font-weight: bold;
}

.close:hover,
.close:focus {
    color: #000;
    text-decoration: none;
    cursor: pointer;
}

.modal-header {
    padding: 2px 16px;
    background-color: #90CAF9;
    color: white;
}

.modal-body {padding: 2px 16px;}

</style>
<title>Academy</title>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="https://www.w3schools.com/w3css/4/w3.css">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Raleway">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
<style>
html,body,h1,h2,h3,h4,h5 {font-family: "Raleway", sans-serif}
</style>
<body class="w3-light-grey">

<!-- Top container -->
<div class="w3-bar w3-top w3-black w3-large" style="z-index:4">
  <button class="w3-bar-item w3-button w3-hide-large w3-hover-none w3-hover-text-light-grey" onclick="w3_open();"><i class="fa fa-bars"></i>  Menu</button>
  <div class="w3-bar-item w3-right">
    <a rel="nofollow" data-method="delete" href="/logout" class="fa fa-sign-out" aria-hidden="true"></a>
  </div>
</div>

<!-- Sidebar/menu -->
<nav class="w3-sidebar w3-collapse w3-white w3-animate-left" style="z-index:3;width:300px;" id="mySidebar"><br>
  <div class="w3-container w3-row">
    <div class="w3-col s4">
      <img src="/w3images/avatar2.png" class="w3-circle w3-margin-right" style="width:46px">
    </div>
    <div class="w3-col s8 w3-bar">
      <span>Bem vindo, <strong><%= @admin.name %></strong></span><br>
      <a href="#" class="w3-bar-item w3-button"><i class="fa fa-envelope"></i></a>
      <a href="#" class="w3-bar-item w3-button"><i class="fa fa-user"></i></a>
      <a href="#" class="w3-bar-item w3-button"><i class="fa fa-cog"></i></a>
    </div>
  </div>
  <hr>
  <div class="w3-container">
    <h5>Dashboard</h5>
  </div>
  <div class="w3-bar-block">
    <a href="#" class="w3-bar-item w3-button w3-padding-16 w3-hide-large w3-dark-grey w3-hover-black" onclick="w3_close()" title="close menu"><i class="fa fa-remove fa-fw"></i>  Close Menu</a>
    <a href="/" class="w3-bar-item w3-button w3-padding "><i class="fa fa-home fa-fw"></i>  home</a>
    <a href="plan_managers" class="w3-bar-item w3-button w3-padding w3-blue"><i class="fa fa-eye fa-fw"></i>  Planos</a>
    <a href="service_managers" class="w3-bar-item w3-button w3-padding"><i class="fa fa-eye fa-fw"></i>  Serviços</a>
    <a href="admin_managers" class="w3-bar-item w3-button w3-padding"><i class="fa fa-users fa-fw"></i>  Gerentes</a>
    <a href="gyms" class="w3-bar-item w3-button w3-padding"><i class="fa fa-bullseye fa-fw"></i>  Academias</a>
    <a href="gym_payment_histories" class="w3-bar-item w3-button w3-padding"><i class="fa fa-diamond fa-fw"></i>  Pagamentos</a>
    <a href="#" class="w3-bar-item w3-button w3-padding"><i class="fa fa-cog fa-fw"></i>  Configurações</a><br><br>
    <a href="/logout" class="w3-bar-item w3-button w3-padding" rel="nofollow" data-method="delete"><i  class="fa fa-sign-out"></i>  Sair</a><br><br>
  </div>
</nav>


<!-- Overlay effect when opening sidebar on small screens -->
<div class="w3-overlay w3-hide-large w3-animate-opacity" onclick="w3_close()" style="cursor:pointer" title="close side menu" id="myOverlay"></div>

<!-- !PAGE CONTENT! -->
<div class="w3-main" style="margin-left:300px;margin-top:43px;">

  <!-- Content -->
  <div class="row">
      <section class="col-lg-12 connectedSortable">
        <table class="table table-hover">
          <thead>
            <tr>
              <th>Nome</th>
              <th>Preço</th>
              <th colspan="3"></th>
            </tr>
          </thead>

          <tbody>
            <% @plan_managers.each do |plan_manager| %>
              <tr onclick="getServicos(<%=plan_manager.id%>)">
                <td><%= plan_manager.name %></td>
                <td><%= plan_manager.price %></td>
                <td><%= link_to 'Edit', edit_plan_manager_path(plan_manager) %></td>
                <td><%= link_to 'Destroy', plan_manager, method: :delete, data: { confirm: 'Are you sure?' } %></td>
              </tr>
            <% end %>
          </tbody>
        </table>
      </section>
    </div>

    <% if @admin %>
      <div class="row">
        <div class="col-lg-offset-5 col-lg-2">
          <a href="/plan_managers/new" class="btn btn-primary" role="button">Novo plano</a>
        </div>
      </div>
    <% end %>
  </section>

  <!-- The Modal -->
  <div id="myModal" class="modal">
    <!-- Modal content -->
    <div class="modal-content">
      <div class="modal-header">
        <span class="close">&times;</span>
        <h4>Serviços</h4>
      </div>
      <div class="modal-body">
        <p id="text"></p>
      </div>
    </div>

  </div>
  <!-- Content -->

  <!-- Footer -->
  <footer class="w3-container w3-padding-16 w3-light-grey">
    <p>All rights reserved Version: beta </p>
  </footer>


  <!-- End page content -->
</div>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<script>
// Get the Sidebar
var mySidebar = document.getElementById("mySidebar");

// Get the DIV with overlay effect
var overlayBg = document.getElementById("myOverlay");

// Toggle between showing and hiding the sidebar, and add overlay effect
function w3_open() {
    if (mySidebar.style.display === 'block') {
        mySidebar.style.display = 'none';
        overlayBg.style.display = "none";
    } else {
        mySidebar.style.display = 'block';
        overlayBg.style.display = "block";
    }
}

// Close the sidebar with the close button
function w3_close() {
    mySidebar.style.display = "none";
    overlayBg.style.display = "none";
}

function getServicos(id){
      $.ajax({
       type: "GET",
       url: "plan_managers/" + id,
       statusCode: {
         200: function(data) {
           openModal(data.message.service,data.message.price);
         }
        }
       });
    }

function openModal(service,value){
  // Get the modal
  console.log(service);
  var modal = document.getElementById('myModal');
  modal.style.display = "block";

  // Get the <span> element that closes the modal
  var span = document.getElementsByClassName("close")[0];

  // When the user clicks on <span> (x), close the modal
  span.onclick = function() {
      modal.style.display = "none";
  }

  // When the user clicks anywhere outside of the modal, close it
  window.onclick = function(event) {
      if (event.target == modal) {
          modal.style.display = "none";
      }
  }

  var text = "";
  for (i = 0; i < service.length; i++) {
      text += "<h5>" + service[i] + " (" + value[i] + "R$) </h5>";
  }

  document.getElementById("text").innerHTML = text;

}

</script>
</body>
</html>

app/views/plan_managers/new.html.erb
<section class="content-header">
  <ol class="breadcrumb">
    <li><a href="/"><i class="fa fa-dashboard"></i>Home</a></li>
    <li class="active">Cadastro de planos</li>
  </ol>
</section>

<div class="text-center"> <p class="text-primary"> <h3>Cadastro de planos</h3></p> </div>
<br/>
<div class="row">
  <div class="col-lg-6">
    <%= render 'form', plan_manager: @plan_manager %>
  </div>

</div>

app/views/plan_managers/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @plan_manager.name %>
</p>

<p>
  <strong>Price:</strong>
  <%= @plan_manager.price %>
</p>

<%= link_to 'Edit', edit_plan_manager_path(@plan_manager) %> |
<%= link_to 'Back', plan_managers_path %>